<!DOCTYPE html>
<html>

<head>
    <meta charset="utf-8">
    <title>SlavDrive.md</title>
    <link rel="stylesheet" href="SlavDrive.css"/>
</head>

<body id="preview">
    <h1 class="code-line" data-line-start=0 data-line-end=1><a id="SlavDrive_0"></a>SlavDrive</h1>
    <h3 class="code-line" data-line-start=2 data-line-end=3><a id="Contents_2"></a>Contents</h3>
    <ul>
        <li class="has-line-data" data-line-start="3" data-line-end="8">
            <h5 class="code-line" data-line-start=3 data-line-end=4><a id="1_Overview_3"></a>1. Overview</h5>
            <ul>
                <li class="has-line-data" data-line-start="4" data-line-end="5">
                    <h6 class="code-line" data-line-start=4 data-line-end=5><a id="11_Dashboard_4"></a>1.1 Dashboard
                    </h6>
                </li>
                <li class="has-line-data" data-line-start="5" data-line-end="6">
                    <h6 class="code-line" data-line-start=5 data-line-end=6><a id="12_Upload_5"></a>1.2 Upload</h6>
                </li>
                <li class="has-line-data" data-line-start="6" data-line-end="7">
                    <h6 class="code-line" data-line-start=6 data-line-end=7><a id="13_Map_6"></a>1.3 Map</h6>
                </li>
                <li class="has-line-data" data-line-start="7" data-line-end="8">
                    <h6 class="code-line" data-line-start=7 data-line-end=8><a id="14_User_profile_7"></a>1.4 User
                        profile</h6>
                </li>
            </ul>
        </li>
        <li class="has-line-data" data-line-start="8" data-line-end="9">
            <h5 class="code-line" data-line-start=8 data-line-end=9><a id="2_Project_analysis_8"></a>2. Project analysis
            </h5>
        </li>
        <li class="has-line-data" data-line-start="9" data-line-end="10">
            <h5 class="code-line" data-line-start=9 data-line-end=10><a id="3_Project_structure_9"></a>3. Project
                structure</h5>
        </li>
        <li class="has-line-data" data-line-start="10" data-line-end="11">
            <h5 class="code-line" data-line-start=10 data-line-end=11><a id="4_Route_data_file_example_10"></a>4. Route
                data file example</h5>
        </li>
        <li class="has-line-data" data-line-start="11" data-line-end="13">
            <h5 class="code-line" data-line-start=11 data-line-end=12><a
                    id="5_Code_overview_of_most_important_functions_11"></a>5. Code overview of most important functions
            </h5>
        </li>
    </ul>
    <h2 class="code-line" data-line-start=13 data-line-end=14><a id="1_Overview_13"></a>1. Overview</h2>
    <p class="has-line-data" data-line-start="14" data-line-end="15">Our application/page is divided into 4 sections:
    </p>
    <ul>
        <li class="has-line-data" data-line-start="15" data-line-end="16">
            <h6 class="code-line" data-line-start=15 data-line-end=16><a id="1_Dashboard_15"></a>1. Dashboard</h6>
        </li>
        <li class="has-line-data" data-line-start="16" data-line-end="17">
            <h6 class="code-line" data-line-start=16 data-line-end=17><a id="2_Upload_16"></a>2. Upload</h6>
        </li>
        <li class="has-line-data" data-line-start="17" data-line-end="18">
            <h6 class="code-line" data-line-start=17 data-line-end=18><a id="3_Map_17"></a>3. Map</h6>
        </li>
        <li class="has-line-data" data-line-start="18" data-line-end="19">
            <h6 class="code-line" data-line-start=18 data-line-end=19><a id="4_User_profile_18"></a>4. User profile</h6>
        </li>
    </ul>
    <p class="has-line-data" data-line-start="19" data-line-end="20">To navigate, user can either scroll down/up the
        page or use the navigation bar on the left side of the screen.</p>
    <img src="Fig1.png">
    <h3 class="code-line" data-line-start=20 data-line-end=21><a id="1a_Dashboard_20"></a>1.a) Dashboard</h3>
    <p class="has-line-data" data-line-start="21" data-line-end="22">On the dashboard user can see his general info i.e.
        average fuel consumption, distance traveled, duration of the travel and elevation. As well as the charts showing
        the performance in the last day, month and year.</p>
    <img src="Fig2.png">
    <h3 class="code-line" data-line-start=23 data-line-end=24><a id="1b_Upload_23"></a>1.b) Upload</h3>
    <p class="has-line-data" data-line-start="24" data-line-end="25">Upload section is used to upload your data to the
        application. You simply drag the file(s) containing the route data to the central box or you choose them by
        clicking the Choose Files button and then you select the file(s) you want to upload from your file system. After
        you drag or select the files, they are automatically loaded by the application and the first 100 points from the
        file(s) are shown in the browser. Meta-info about the files and the parse status message(s) are also shown. For
        an example of a route data file see section 4.</p>
    <img src="Fig3.png">
        <h3 class="code-line" data-line-start=26 data-line-end=27><a id="1c_Map_26"></a>1.c) Map</h3>
    <p class="has-line-data" data-line-start="27" data-line-end="28">Map shows the start and the end point (marker) of
        the last route.</p>
    <img src="Fig4.png">
    <h3 class="code-line" data-line-start=29 data-line-end=30><a id="1d_User_profile_29"></a>1.d) User profile</h3>
    <p class="has-line-data" data-line-start="30" data-line-end="31">Shows the general info about the user.</p>
    <img src="Fig5.png">
    <h2 class="code-line" data-line-start=32 data-line-end=33><a id="2_Project_analysis_32"></a>2. Project analysis</h2>
    <p class="has-line-data" data-line-start="33" data-line-end="34">General functional requirements of the program are
        presented in the form of a use case diagram in the figure below. This diagram shows the possible interaction of
        the system user with the system itself.</p>
    <img src="Fig6.png">
    <p class="has-line-data" data-line-start="35" data-line-end="36">After opening the page user can upload the file by
        dragging it to the central box or choosing file from the file system. Then, the data about the route is
        displayed on the dashboard - user can analyse the data using a map and graphs. Also, it is possible to view
        account information.</p>
    <p class="has-line-data" data-line-start="37" data-line-end="38">While analyzing the problem, the following
        non-functional requirements were identified:</p>
    <ul>
        <li class="has-line-data" data-line-start="38" data-line-end="39">project environment: Visual Studio Code</li>
        <li class="has-line-data" data-line-start="39" data-line-end="40">frontend: JavaScript, HTML, CSS</li>
        <li class="has-line-data" data-line-start="40" data-line-end="41">Web Storage for data storage</li>
        <li class="has-line-data" data-line-start="41" data-line-end="43">data format: JSON</li>
    </ul>
    <h2 class="code-line" data-line-start=43 data-line-end=44><a id="3_Project_structure_43"></a>3. Project structure
    </h2>
    <img src="Fig7.png">
    <ul>
        <li class="has-line-data" data-line-start="44" data-line-end="45">.vscode (auto generated folders from VS code)
        </li>
        <li class="has-line-data" data-line-start="45" data-line-end="50">assets
            <ul>
                <li class="has-line-data" data-line-start="46" data-line-end="47">css (contains all the .css files)</li>
                <li class="has-line-data" data-line-start="47" data-line-end="48">demo (contains all user made .js
                    files)</li>
                <li class="has-line-data" data-line-start="48" data-line-end="49">img (contains the images for project)
                </li>
                <li class="has-line-data" data-line-start="49" data-line-end="50">js (contains all the core .js files as
                    well as plugins)</li>
            </ul>
        </li>
        <li class="has-line-data" data-line-start="50" data-line-end="51">node_modules (packages from NPM)</li>
        <li class="has-line-data" data-line-start="51" data-line-end="52">webpages (single html for application)</li>
        <li class="has-line-data" data-line-start="52" data-line-end="54">7.txt &amp; 8.txt (test data)</li>
    </ul>
    <h2 class="code-line" data-line-start=54 data-line-end=55><a id="4_Route_data_file_example_54"></a>4. Route data
        file example</h2>
    <p class="has-line-data" data-line-start="55" data-line-end="62">Every line in the file represents one point in the
        route. Every line is in the following format: RouteID, Timestamp, Longitude, Latitude<br>
        Below is the content of one of the file that is used for testing purposes:<br>
        8,2008-02-04 07:01:13,116.36606,39.6841<br>
        8,2008-02-05 07:01:35,116.36606,39.68409<br>
        8,2008-02-06 07:02:00,116.36605,39.68409<br>
        8,2008-02-07 07:02:45,116.36611,39.68408<br>
        8,2008-02-08 07:00:37,116.36615,39.68413</p>
    <h2 class="code-line" data-line-start=63 data-line-end=64><a
            id="5_Code_overview_of_most_important_functions_63"></a>5. Code overview of most important functions</h2>
    <h4 class="code-line" data-line-start=65 data-line-end=66><a id="demojs_65"></a>demo.js</h4>
    <h5 class="code-line" data-line-start=66 data-line-end=67><a id="Initialization_of_the_app_66"></a>Initialization of
        the app</h5>
    <ul>
        <li class="has-line-data" data-line-start="67" data-line-end="68">called at the very begging in order to
            calculate data from local storage and show it on dashboard,</li>
        <li class="has-line-data" data-line-start="68" data-line-end="70">initialize map and first and last coordinate
            to the map</li>
    </ul>
    <p class="has-line-data" data-line-start="70" data-line-end="75">function complexInitGoogleMaps(){<br>
        initGoogle();<br>
        var map = demo.initGoogleMaps();<br>
        demo.addMarkersToMap(map);<br>
        }</p>
    <h5 class="code-line" data-line-start=76 data-line-end=77><a id="Map_visualization_76"></a>Map visualization</h5>
    <ul>
        <li class="has-line-data" data-line-start="77" data-line-end="78">function is used to show the map on
            webpage,set map options.</li>
        <li class="has-line-data" data-line-start="78" data-line-end="80">return value: map object</li>
    </ul>
    <p class="has-line-data" data-line-start="80" data-line-end="86">initGoogleMaps: function () {<br>
        var objects = getObjects();<br>
        var start_object = objects[0];<br>
        var start_coordinate = new google.maps.LatLng(Number(start_object.lat), Number(start_object.lng));<br>
        …<br>
        }</p>
    <h5 class="code-line" data-line-start=87 data-line-end=88><a id="Dragdrop_87"></a>Drag&amp;drop</h5>
    <p class="has-line-data" data-line-start="88" data-line-end="89">In order to use drag&amp;drop API there are
        functions:</p>
    <ul>
        <li class="has-line-data" data-line-start="89" data-line-end="90">allowDrop(ev)</li>
        <li class="has-line-data" data-line-start="90" data-line-end="91">drag(ev)</li>
        <li class="has-line-data" data-line-start="91" data-line-end="93">drop(ev)</li>
    </ul>
    <h4 class="code-line" data-line-start=93 data-line-end=94><a id="storagejs_93"></a>storage.js</h4>
    <p class="has-line-data" data-line-start="94" data-line-end="95">There is a function make objects that makes an
        array of objects every object consists of:</p>
    <ul>
        <li class="has-line-data" data-line-start="95" data-line-end="96">id</li>
        <li class="has-line-data" data-line-start="96" data-line-end="97">date</li>
        <li class="has-line-data" data-line-start="97" data-line-end="98">lng</li>
        <li class="has-line-data" data-line-start="98" data-line-end="100">lat</li>
    </ul>
    <h5 class="code-line" data-line-start=100 data-line-end=101><a id="Function_save_100"></a>Function save</h5>
    <ul>
        <li class="has-line-data" data-line-start="101" data-line-end="102">Takes the given data and stores it</li>
        <li class="has-line-data" data-line-start="102" data-line-end="104">Web Storage API is used</li>
    </ul>
    <p class="has-line-data" data-line-start="104" data-line-end="108">function save(text){<br>
        var objects = make_objects(text);<br>
        localStorage.objects = JSON.stringify(objects);<br>
        }</p>
    <h5 class="code-line" data-line-start=109 data-line-end=110><a id="getObjects_function_109"></a>getObjects()
        function</h5>
    <p class="has-line-data" data-line-start="110" data-line-end="111">Loads locally stored objects which are consisted
        of:</p>
    <ul>
        <li class="has-line-data" data-line-start="111" data-line-end="112">id</li>
        <li class="has-line-data" data-line-start="112" data-line-end="113">date</li>
        <li class="has-line-data" data-line-start="113" data-line-end="114">lng</li>
        <li class="has-line-data" data-line-start="114" data-line-end="116">lat</li>
    </ul>
    <h4 class="code-line" data-line-start=116 data-line-end=117><a id="calculatorjs_116"></a>calculator.js</h4>
    <h5 class="code-line" data-line-start=117 data-line-end=118><a id="initGoogle_function_117"></a>initGoogle()
        function</h5>
    <ul>
        <li class="has-line-data" data-line-start="118" data-line-end="119">initGoogle function loads array of objects.
            each object is consisted of:</li>
        <li class="has-line-data" data-line-start="119" data-line-end="120">id</li>
        <li class="has-line-data" data-line-start="120" data-line-end="121">date</li>
        <li class="has-line-data" data-line-start="121" data-line-end="122">lng</li>
        <li class="has-line-data" data-line-start="122" data-line-end="125">lat<br>
            lng and lat are used to make google.maps.LatLng object which holds the coordinate.<br>
            Every google.maps.LatLng object is saved in locations array. Total distance and total duration between each
            point are calculated in calculate() function. Result is shown on the dashboard.</li>
    </ul>

    <hr>
    <h4 style="text-align: right;">
        Team members:
        <ul style="list-style-type: none;">
            <li>Luka Vukadinovic</li>
            <li>Aleksandar Vujinovic</li>
            <li>Saso Pavlovic</li>
            <li>Anna Ignatowicz</li>
        </ul>
    </h4>
</body>

</html>